From 2010c04a80b1c100f5cae6872ff7a5897d8e5cb3 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Apr 16 2015 21:57:12 +0000
Subject: [PATCH 10/1001] Add a sticky note.


---

diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index f30c8d6..2e495f7 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -1,9 +1,11 @@
 import dummy
 import stats
 import rules
+import sticky
 
 registry = {
     'dummy': dummy.render,
     'stats': stats.render,
     'rules': rules.render,
+    'sticky': sticky.render,
 }
diff --git a/hubs/widgets/chrome.py b/hubs/widgets/chrome.py
index 7862e49..1f8d399 100644
--- a/hubs/widgets/chrome.py
+++ b/hubs/widgets/chrome.py
@@ -1,7 +1,7 @@
 from base import wraps
 
 _panel_template = """
-<div class="panel panel-default">
+<div class="panel {klass}">
   {heading}
   <div class="panel-body">
     {content}
@@ -18,7 +18,7 @@ _panel_heading_template = """
 """
 
 
-def panel(title=None):
+def panel(title=None, klass="panel-default"):
     def decorator(func):
         @wraps(func)
         def inner(*args, **kwargs):
@@ -26,6 +26,6 @@ def panel(title=None):
             if title:
                 heading = _panel_heading_template.format(title=title)
             content = func(*args, **kwargs)
-            return _panel_template.format(content=content, heading=heading)
+            return _panel_template.format(content=content, heading=heading, klass=klass)
         return inner
     return decorator
diff --git a/hubs/widgets/sticky.py b/hubs/widgets/sticky.py
new file mode 100644
index 0000000..2246ae1
--- /dev/null
+++ b/hubs/widgets/sticky.py
@@ -0,0 +1,12 @@
+from chrome import panel
+from base import argument
+
+import hubs.validators as validators
+
+@panel(title='Sticky Note', klass="panel-info")
+@argument(name="text", default="Lorem ipsum dolor...",
+          validator=validators.text,
+          help="Some dummy text to display.")
+def render(request, session, widget, text):
+    # TODO -- render with markdown
+    return text
diff --git a/populate.py b/populate.py
index 0398028..439a941 100644
--- a/populate.py
+++ b/populate.py
@@ -24,7 +24,12 @@ widget = hubs.models.Widget(plugin='rules', index=1,
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='dummy', index=2)
 hub.widgets.append(widget)
-widget = hubs.models.Widget(plugin='dummy', index=0, left=True)
+widget = hubs.models.Widget(plugin='sticky', index=0, left=True,
+                            _config=json.dumps({
+                                'text': 'This is a sticky note.',
+                            }))
+hub.widgets.append(widget)
+widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
 hub.widgets.append(widget)
 
 session.commit()

